package xor;

import java.util.Vector;
import java.util.Random;
import java.awt.*;
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Y.Nakonech
 */


public class GameField {

    public static final Boolean FIGURE_X = Boolean.TRUE;
    public static final Boolean FIGURE_O = Boolean.FALSE;
    public static final Boolean FIGURE_FREE = null;

    private Boolean field [][];
    private int lineToWin;

    /**
     * Constuctor with default dimension and line length
     */

        public GameField() {
            //здесь указываем сколько выигрывать будет
            //5 по вертикали и 5 по горизонтали
        this(5, 5);
        }

    /*
     * Constructor with field dimension
     * @param  size of field (dimension x dimension)
     * @param  lineToWin line length to win
     */
    public GameField(int dimension, int lineToWin) {
        field = new Boolean[15][15];  //dimension][dimension];
        this.lineToWin = lineToWin;
    }

    @Override
    public String toString() {
        StringBuffer buf = new StringBuffer();
        System.out.print(' '/* + ' '*/);
        for(int x = 0; x < field.length; x++){
            System.out.print(" " + (x+1));
            for(int y = 0; y < field[x].length; y++){
                if (y==0){
                    if  (x==0) buf.append('\n');
                    buf.append((x+1));
                    buf.append('|');
                } else {
                    buf.append('|');
                }
                if (field[x][y] == FIGURE_X) {
                    buf.append('X');
                } else if (field[x][y] == FIGURE_O) {
                    buf.append('O');
                } else {
                    buf.append(' ');
                }
            }
            buf.append("|\n");
        }

        return buf.toString();
    }

    /**
     * adds a figure into field
     * @param type true - X
     * @return true if game ended
     * @throws IllegalArgumentException - this field are busy
     */
    public boolean put(Boolean type, int x, int y){
        if (field[x][y] != FIGURE_FREE) throw new IllegalArgumentException("Place " + x + "-" + y + " are busy.");

        field[x][y] = type;

        return isEnded(x, y);
    }

    // {x, y}
    private static final int[][] CHECK_MATRIX = {{1, 0}, {1, 1}, {0, 1}};

    /**
     * Checks if game has been ended
     * @param x x pos of added figure
     * @param y y pos of added figure
     * @return true if game ended
     */
    private boolean isEnded(int x, int y) {
        for (int i = 0; i < CHECK_MATRIX.length; i++) {
            int cnt = 1;
            for (int sign = +1; sign != -3; sign -= 2) {
                for (int j = 1; ; j++) {
                    try {
                        if (field[x][y] == field[x + sign * CHECK_MATRIX[i][0] * j][y + sign * CHECK_MATRIX[i][1] * j]) {
                            cnt++;
                        } else {
                            break;
                        }
                    } catch (IndexOutOfBoundsException e){
                        break;
                    }
                }
            }
            if (cnt >= lineToWin) return true;
        }
        return false;
    }

    /**
     * Checks if field are full
     * @return true if full
     */
    public boolean isFieldFull(){
        for(int x = 0; x < field.length; x++){
            for(int y = 0; y < field[x].length; y++){
                if (field[x][y] == FIGURE_FREE) return false;
            }
        }
        return true;
    }



    // computer action

    private Random rand = new Random();

    public String stupidComputerAction(){
        Vector freeFields = new Vector();

        for(int x = 0; x < field.length; x++){
            for(int y = 0; y < field[x].length; y++){
                if (field[x][y] == FIGURE_FREE) freeFields.add(new Point(x+1,y+1));
            }
        }

        Point act = (Point) freeFields.elementAt(rand.nextInt()%freeFields.size());
        System.out.println((int)act.getX() + "," + (int)act.getY());
        return (int)act.getX() + "," + (int)act.getY();
    }

}
